-- NpcChitChat prints text from NPC speech bubbles into chat.
-- version 2

require "Apollo"
require "ChatSystemLib"

local addon = {messages = {}}

function addon:on_bubble(unit, text)
	if text == "###" then	-- exclude xml bubbles
	elseif self.messages[text] then	-- exclude NPC Say
		self.messages[text] = nil
	else
		ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_NPCYell, text, unit:GetName())
	end
end

function addon:on_msg(channel, msg)
	if channel:GetType() == ChatSystemLib.ChatChannel_NPCSay and not msg.bShowChatBubble then	-- bubbles are still generated independently
		local text = ""
		for _, v in ipairs(msg.arMessageSegments) do
			text = text .. v.strText
		end
		self.messages[text] = true
	end
end

function addon:OnLoad()
	Apollo.RegisterEventHandler("UnitTextBubbleCreate", "on_bubble", self)
	Apollo.RegisterEventHandler("ChatMessage", "on_msg", self)
end

Apollo.RegisterAddon(addon)
